<?php
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecat extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _header()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_products'", '');
            return '';
        }
        public function _navigation()
        {
            global $parser;
            $action =  (isset($_POST["action"])) ? $_POST["action"] : '';
            $formid =  (isset($_POST["formid"])) ? $_POST["formid"] : ''; // id of row element for contextmenu
            $orderid =  (isset($_REQUEST["orderid"])) ? $_REQUEST["orderid"] : '';
            $addformid =  (isset($_REQUEST["addformid"])) ? $_REQUEST["addformid"] : '';
            $onselect =  (isset($_REQUEST["onselect"])) ? $_REQUEST["onselect"] : '';
            $perm = $parser->checkPerms('wprod_rights_prodcats');
            if(!$perm['r']) die($parser->gt('not_perms'));
            $tree = new docTree();
            //$tree->caption = $parser->gt('categories');
            $tree->unselect_text = '<b>'.$parser->gt('allcategories').'</b>';
            $tree->f = new wproducts_models_categories();

            $tree->q->select('id');
            $tree->q->lselect('name');
            $tree->q->select('isfolder');
            $tree->q->select('parent');
            $tree->q->select('totalitems');
            $tree->q->select('0 AS treetype');
            $tree->q->select('published');
            $tree->q->from('wprod_categories');
            $tree->q->where("id<>'0'");

            $tree->q->where('parent=:parent:');
            $tree->q->lorderby('name');

            if(!$addformid and !$onselect)
            {
                $tree->editing = $perm['u'];
                $tree->adding = $perm['c'];
                $tree->deleting = $perm['d'];
            }

            $tree->leaf_func = 'reloadgrid';
            $tree->folder_func = 'reloadgrid';
            $tree->unselect = true;
            $parser->invokeEvent('wprod_events_catbtree', array('obj' => $tree, 'addformid' => $addformid, 'onselect' => $onselect, 'orderid' => $orderid));
            $tree->show();
            return '';
        }
        public function _content()
        {
            global $parser;
            //$active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $filter_manufacter = (isset($_REQUEST['filter_manufacter'])) ? $_REQUEST['filter_manufacter'] : '';
            $filter_published = (isset($_REQUEST['filter_published'])) ? $_REQUEST['filter_published'] : '';
            $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
            $subcat_id = (isset($_REQUEST['subcat_id'])) ? $_REQUEST['subcat_id'] : '';
            $addformid =  (isset($_REQUEST["addformid"])) ? $_REQUEST["addformid"] : '';
            $onselect =  (isset($_REQUEST["onselect"])) ? $_REQUEST["onselect"] : '';
            $orderid =  (isset($_REQUEST["orderid"])) ? $_REQUEST["orderid"] : '';
            $pricefield =  (isset($_REQUEST["pricefield"])) ? $_REQUEST["pricefield"] : 'price';
            $editable = (($addformid == '') and ($onselect == '')) ? true : false;

            $fn = __FILE__;
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $w = new wAjaxGrid();
            $w->edit_table_alias = 'o';

            $w->f = new wproducts_models_products();
            $w->en_mainmenu = false;
            $a = $parser->utils->getFieldsFromSql('SELECT id, name_'.$parser->lang_suff.", isfolder, parent FROM wprod_categories WHERE id='".$subcat_id."'", array(0,'',0,0), 'num');

            if($subcat_id) $w->caption = $a[1];
                else $w->caption = $parser->gt('allcategories');

            $par = array('edit' => $editable && $this->perm['u']);

            $w->q->select('o.id',  $parser->gt('id'));
            $w->q->select('o.artikul', $parser->gt('artikul', $fn), $par);
            $w->q->select('o.model', $parser->gt('model', $fn), $par);
            if($editable) $w->q->select('o.name', $parser->gt('name', $fn), array('lang' => true, 'edit' => $this->perm['u']));
                else $w->q->select('o.name', $parser->gt('name', $fn), array('lang' => true, 'func' => 'openForm'));

            $b = $parser->utils->getFieldsFromSql("SELECT flt1, flt2, flt3, str1_".$parser->lang_suff." FROM sys_objects WHERE objid='".$parser->gs('wprod_setting_curr')."'", array(0,0,0,''), 'num');
            if($parser->gt('wprod_setting_showtaxes'))  $w->q->select('o.tax'.$pricefield, $parser->gt('taxprice', $fn).' '.$b[3]);
                else $w->q->select('o.'.$pricefield, $parser->gt('price', $fn).' '.$b[3]);
            $w->q->select('o.income-o.expense AS qty', $parser->gt('qtys', $fn));
            $w->q->select('o.masterid', 'ERP Id');
            $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
            $w->addHidden('addformid', $addformid);
            $w->addHidden('onselect', $onselect);
            $w->addHidden('orderid', $orderid);
            $w->addHidden('pricefield', $pricefield);
            if($filter_color)
            {
                $w->q->where("o.color='".$filter_color."'");
                $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
                $w->f->setFieldVal('color', $filter_color);
            }
            switch($filter_published)
            {
                case 1:     $w->q->where("o.published=1");
                         $w->f->extra_deleteAll_sql .= "AND published=1 ";
                break;
                case 2:     $w->q->where("o.published=0");
                         $w->f->extra_deleteAll_sql .= "AND published=0 ";
                break;
            }
            if($filter_manufacter)
            {
                $mfilter_manufacter = $parser->utils->addQuots($filter_manufacter);
                $w->q->where("o.manufacter IN(".$mfilter_manufacter.")");
                $w->f->extra_deleteAll_sql .= "AND manufacter IN(".$mfilter_manufacter.") ";
                $w->f->setFieldVal('manufacter', $filter_manufacter);
            }
            $w->q->from('wprod_products o');
            $w->q->where("o.id<>'0'");
            if($a[2])
            {
                // folder
                $w->q->lselect('c.name AS catname', $parser->gt('category'));
                if($subcat_id) $w->q->where("o.category IN(".$parser->utils->getAllChilds('select id from wprod_categories where id<>0 and parent=:parent:',
                    $subcat_id, false, 0, false).")");
                $w->q->from('wprod_categories c');
                $w->q->where("o.category=c.id");
            }
            elseif($subcat_id)
            {
                $w->q->where("o.category=".$subcat_id);
            }
            $w->adding = $this->perm['c'];
            $w->copying = $this->perm['c'];
            $w->deleting = $this->perm['d'];
            $w->multiselect = $this->perm['d'];

            $w->q->lorderby('o.name');

            $pars['name'] = 'filter_color';
            $pars['onchange'] = 'reloadgridm()';
            $pars['val'] = 0;
            $pars['colored'] = true;
            $pars['options'] = array($parser->gt('allcolors'));
            $w->addCell($parser->utils->dropdownMenu($pars));

            $this->popup_script = true;
            $pars = array();
            $pars['name'] = 'filter_manufacter';
            $pars['emptyval'] = 0;
            $pars['tree_btn'] = 0;
            $pars['emptyrefval'] = $parser->gt('allmanufacter',__FILE__);
            $pars['onchange'] = 'reloadgridm()';
            $pars['objtype'] = 'wprod_brands';
            $w->addCell($parser->utils->finder($pars));

            $pars['name'] = 'filter_published';
            $pars['onchange'] = 'reloadgridm()';
            $pars['val'] = 0;
            $pars['options'] = array($parser->gt('allenabled',__FILE__), $parser->gt('yesitis'), $parser->gt('noitisnot'));
            $w->addCell($parser->utils->dropdownMenu($pars));

            $w->addSearchField('o.artikul', $parser->gt('artikul'), 'C');
            $w->addSearchField('o.model', $parser->gt('model'), 'C');
            $w->laddSearchField('o.name', $parser->gt('name'));

            $w->addSearchField('o.income-o.expense', $parser->gt('quantity'), 'F');
            if($parser->gt('wcomm_setting_showtaxes')) $w->addSearchField('o.taxprice', $parser->gt('taxprice'), 'F');
                else $w->addSearchField('o.price', $parser->gt('price'), 'F');
            $w->addSearchField('o.comments', $parser->gt('comments'), 'I');
            $w->addSearchField('o.rating', $parser->gt('rating'), 'I');
            $w->addSearchField('o.photos', $parser->gt('photos'), 'I');
            $w->addSearchField('o.viewed', $parser->gt('viewed'), 'I');
            $w->addSearchField('o.prodtype', $parser->gt('prodtype'), 'wprod_prodtypes');
            $w->addSearchField('o.manufacter', $parser->gt('manufacter'), 'wprod_brands');
            $w->addSearchField('o.published', $parser->gt('published'), 'L');
            $w->addSearchField('o.newitem', $parser->gt('newitem'), 'L');
            $w->addSearchField('o.ourchoice', $parser->gt('ourchoice'), 'L');
            $w->addSearchField('o.needdelivery', $parser->gt('needdelivery'), 'L');

            $w->addingpars = 'category='.$subcat_id;
            if($editable)
            {
                $w->f->setFieldVal('category', $subcat_id); // Default detail table
                $w->f->setFieldVal('weightclass', $parser->gs('wprod_setting_weightclass'));
                $w->f->setFieldVal('lengthclass', $parser->gs('wprod_setting_lengthclass'));
                $w->f->setFieldVal('qtyclass', $parser->gs('wprod_setting_qtyclass'));
                $w->f->setFieldVal('taxclass', $parser->gs('wprod_setting_taxclass'));
                $w->f->setFieldVal('prodtype', $parser->gs('wprod_setting_prodtype'));
            } else
            {
                $parser->addScript(SYS_BASE_URL.'libs/js/jquery.js');
                $fu = ($onselect) ? 'self.opener.'.$onselect.'(id);' : "openWinc('".$parser->makeUrl($addformid)."', 'productid=' + id + '&orderid=".$orderid."', 700, 500)";
                $src = "<script type=\"text/javascript\">
                function openForm(id, name)
                {
        	    	try
        	    	{
                        ".$fu.";
        	    	} catch(e){}
                }
                function formCallback(id)
                {
        	    	try
        	    	{
        	    	    self.opener.catalogCallback(id);
        	    	} catch(e){}
                }
            	</script>";
                $parser->addScript($src);
               	$src = SYS_BASE_URL.'main/js/popup.js';
                $parser->addScript($src);

            }
            $w->cardurl = $parser->makeUrl('wprod_products_card');
            $w->editing = $this->perm['u'];

            $w->addHidden('subcat_id', $subcat_id);
            $parser->invokeEvent('wprod_events_catblist', array('obj' => $w, 'category' => $subcat_id, 'addformid' => $addformid, 'orderid' => $orderid));
            $w->show();

        }
        public function _footer()
        {

            return "<div style=\"border-top:1px solid #CCCCCC;\"></div>";
        }
    }

    include_once(SYS_BASE_PATH.'main/classes/wajaxtree.class.php');
    class docTree extends wAjaxTree
    {
        public function makeTreeclass($d, $r)
        {
            if(!$r[6]) return 'docunpublished';
            return $d;
        }
        public function makeNotes($d, $r)
        {
            if($r[4]) return ' ('.$r[4].')';
            return '';
        }
    }

    $cat = new wtablecat('wprod_products');
    $cat->perm = $perm;
    $cat->catalog_field = 'category';
    $cat->showTable();

?>