<?php
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecat extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _header()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_lineup_attr'", '');
            return '';
        }

        public function _navigation()
        {
            global $parser;
            include_once(SYS_BASE_PATH.'main/classes/wajaxtree.class.php');
            $tree = new wAjaxTree();

            $tree->unselect_text = '<b>'.$parser->gt('alltypes').'</b>';

            $tree->q->select('id');
            $tree->q->lselect('name');
            $tree->q->select('isfolder');
            $tree->q->select('parent');
            $tree->q->select("'' AS prim");
            $tree->q->select('0 AS treetype');
            $tree->q->from('wprod_lineups');
            $tree->q->where("id<>'0'");

            $tree->q->where('parent=:parent:');
            $tree->q->lorderby('name');

            $tree->leaf_func = 'reloadgrid';
            $tree->folder_func = 'reloadgrid';
            $tree->unselect = true;



            $tree->show();
            return '';
        }
        public function _content()
        {
            global $parser;
            $userid = $parser->getUserId();

            $subcat_id = (isset($_REQUEST['subcat_id'])) ? $_REQUEST['subcat_id'] : '';
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $w = new wAjaxGrid();
            $w->edit_table_alias = 'o';
            $w->f = new wproducts_models_lineupattr();
            $w->edit_table_alias = 'o';
            //$w->caption = $parser->gt('wprod_lineup_attr', __FILE__);
            $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_lineup_attr'", '');

            $w->q->select('o.id',  $parser->gt('id'));
            $w->q->from('wprod_lineup_attr o');
            $w->q->where("o.id<>'0'");
            $w->q->orderby('o.id');

            $w->q->lselect('t0.name AS t0name',  $parser->gt('lineup'));
            $w->q->from('wprod_lineups t0');
            $w->q->where('o.lineupid=t0.id');

            $w->q->lselect('t1.name AS t1name',  $parser->gt('attribute'));
            $w->q->from('sys_objects t1');
            $w->q->where('o.attrid=t1.objid');
            $w->q->select('o.sortorder', $parser->gt('sortorder'), array('edit' => $this->perm['u']));

            $w->addSearchField('o.id', $parser->gt('name'), 'C');
            $w->addSearchField('o.lineupid', $parser->gt('lineup'), 'wprod_lineups');
            $w->addSearchField('o.id', $parser->gt('attribute'), 'wprod_prodspecs');
            if($subcat_id)
            {
                $w->q->where("o.lineupid='$subcat_id'");
                $w->f->fields->lineupid->val = $subcat_id;
            }

            $w->editing = $this->perm['u'];
            $w->adding = $this->perm['c'];
            $w->copying = $this->perm['c'];
            $w->deleting = $this->perm['d'];
            $w->multiselect = $this->perm['d'];
            $w->en_mainmenu = false;



            $w->addHidden('subcat_id', $subcat_id);

            $w->show();


        }
        public function _footer()
        {

            return "<div style='border-top:1px solid #CCCCCC;'></div>";
        }
    }

    $cat = new wtablecat('wprod_lineup_attr');
    $cat->perm = $perm;
    $cat->catalog_field = 'lineupid';
    $cat->showTable();

?>