<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_booking extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_booking');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}

protected function _onBeforeInsert()
{
    global $parser;
    $this->id = 0;
    $this->fields->createdon->val = $parser->utils->toDate('', true);
    $s = $this->checkPars();
    if($s) return $s;

    return '';
}

protected function _onBeforeUpdate()
{
    $this->fields->days->ro = false;
    $this->fields->confirmedon->ro = false;
    $s = $this->checkPars();
    if($s) return $s;

    return '';
}

protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        if(!$this->fields->starton->val) $this->fields->starton->val = $parser->utils->toDate('');
        if(!$this->fields->finishon->val) $this->fields->finishon->val = $parser->utils->dateToStr($parser->utils->shiftDates($parser->utils->toDate(''), 6, 'd'));
        //$this->fields->starton->val = $parser->utils->toDate('');
    } else
    {

    }
    $sql = " AND (prodtype='wprod_prodtypes_estate') ";
    $this->setFieldAttr('productid', 'extra_pars', $sql);
    return '';
}



protected function _onUpdate()
{
    $this->fields->days->ro = true;
    $this->fields->confirmedon->ro = true;

    return '';
}

public function checkPars()
{
    global $parser;
    $this->fields->days->newval =  ($parser->utils->strToDate($this->fields->finishon->newval)
    - $parser->utils->strToDate($this->fields->starton->newval)) / (3600*24) + 1;

    if($parser->utils->strToDate($this->fields->starton->newval) < adodb_mktime(0, 0, 0, adodb_date('m'), adodb_date('d'), adodb_date('Y')))
    return $parser->gt('badperiod');

    // Ckeck dates
    $a = $parser->utils->getFieldsFromSql('SELECT minqty, maxqty
                                           FROM wprod_products WHERE id='.$this->fields->productid->val,
                                           array(0,0), 'num');
    if($this->fields->days->newval <= 0) return $parser->gt('badperiod');
    if($a[0] and ($this->fields->days->newval < $a[0])) return $parser->gt('minperiod','', $a[0]);
    if($a[1] and ($this->fields->days->newval > $a[1])) return $parser->gt('maxperiod','', $a[1]);

    $from = $parser->conn->DBDate($parser->utils->dateToISOformat($this->fields->starton->newval));
    $to = $parser->conn->DBDate($parser->utils->dateToISOformat($this->fields->finishon->newval));
    $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_booking
                                          WHERE (productid=".$this->fields->productid->val.")
                                          AND (id<>".$this->id.")
                                          AND
                                          (
                                              (starton BETWEEN ".$from." AND ".$to.")
                                              OR
                                              (finishon BETWEEN ".$from." AND ".$to.")
                                          )
                                          ", '');
    if($n) return $parser->gt('objectbusy');

    return '';
}

public function onBeforeCopy($id = 0)
{
    parent::onBeforeCopy($id);
    return '';
}

public function onCopy($id = 0)
{
    //global $parser;
    // Copy subobjects from original object

    return '';
}

}

?>