<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_categories extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_categories');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
    $this->extendedTinymce = true;
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    if(!$this->getFieldVal('attrgr')) $this->setFieldVal('attrgr', $parser->gs('wprod_setting_attrgr'));
    return '';
}

protected function _onBeforeUpdate()
{
    global $parser;
    $this->setFieldAttr('updateon', 'ro', 0);
    $this->setFieldNewVal('updateon', $parser->utils->toDate('', true));
    return '';
}

protected function _onUpdate()
{
    $this->setFieldAttr('updateon', 'ro', 1);
    $this->uploadAvatar('wprod_categories', $this->id);
    if($this->fields->parent->val != $this->fields->parent->newval)
    {
        $this->recalc($this->fields->parent->val);
        $this->recalc($this->fields->parent->newval);
    }
    if($this->fields->published->val != $this->fields->published->newval) $this->recalc();
    $this->addLang();
    return '';
}

protected function _onInsert()
{
    $this->addLang();
    return '';
}


protected function _onBeforeShowForm()
{
    global $parser;
    $this->enctype="multipart/form-data";
    if(!$this->id)
    {
        $this->setFieldVal('attrgr', $parser->gs('wprod_setting_attrgr'));
    }
    return '';
}

public function recalc($cat = 0)
{
    global $parser;
    if(!$cat) $cat = $this->id;
    while($cat)
    {
        $parent = $parser->utils->getFieldFromSql("SELECT parent FROM wprod_categories WHERE id=".$cat, 0);
        $a = $parser->utils->getFieldsFromSql("SELECT SUM(totalitems), SUM(CASE WHEN published=1 THEN enitems ELSE 0 END) FROM wprod_categories WHERE parent=".$parent, array(0,0), 'num');
        $parser->conn->Execute("UPDATE wprod_categories SET totalitems=".$a[0].", enitems=".$a[1]." WHERE id=".$parent);
        $cat = $parent;
    }
}

public function addLang($lang = '')
{
    global $parser;
    if(!$parser->config['seo_default_lang']) return;
    $extra_sql = ($lang) ? " AND lang='".$lang."'" : '';
    if($parser->utils->getFieldFromSql("SELECT id FROM wprod_categories_lang ".
                                "WHERE categoryid=".$this->id.$extra_sql, 0)) return;
    $f = new wproducts_models_categorieslang();
    $f->fields->categoryid->val = $this->id;
    $f->fields->name->val = $this->fields->name->val;
    $f->fields->url->val = $this->fields->url->val;
    $f->fields->description->val = $this->fields->description->val;
    $f->fields->meta_title->val = $this->fields->meta_title->val;
    $f->fields->meta_h1->val = $this->fields->meta_h1->val;
    $f->fields->meta_keywords->val = $this->fields->meta_keywords->val;
    $f->fields->meta_description->val = $this->fields->meta_description->val;

    if($lang)
    {
        $f->fields->lang->val = $lang;
        $f->insert();
        return '';
    }

    $rs = $parser->conn->Execute("SELECT objid, str1_".$parser->lang_suff.
    " FROM sys_objects WHERE objtype='sys_langs' and bool1=1");
    while($row = $rs->FetchRow())
    {
        $f->fields->lang->val = $row[1];
        $f->insert();
    }
}


}

?>