<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_products extends wPrototype
{
public $recalc = true;
public $category = 0;

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_products');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->clearprops = true;
    $this->richedit_height = 300;
    $this->extendedTinymce = true;
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    $this->setFieldNewVal('taxprice', $this->addTaxes($this->getFieldNewVal('price')));
    $this->setFieldNewVal('taxcost', $this->addTaxes($this->getFieldNewVal('cost')));

    //if(!$this->getFieldNewVal('taxclass')) $this->setFieldNewVal('taxclass', $parser->gs('wprod_setting_taxclass'));
    if(!strlen($this->getFieldNewVal('taxclass'))) $this->setFieldNewVal('taxclass', $parser->gs('wprod_setting_taxclass'));
    if(!$this->getFieldNewVal('prodtype')) $this->setFieldNewVal('prodtype', $parser->gs('wprod_setting_prodtype'));
    if(!$this->getFieldNewVal('weightclass')) $this->setFieldNewVal('weightclass', $parser->gs('wprod_setting_weightclass'));
    if(!$this->getFieldNewVal('lengthclass')) $this->setFieldNewVal('lengthclass', $parser->gs('wprod_setting_lengthclass'));
    if(!$this->getFieldNewVal('qtyclass')) $this->setFieldNewVal('qtyclass', $parser->gs('wprod_setting_qtyclass'));

    if(!$this->getFieldNewVal('shortname')) $this->setFieldNewVal('shortname', mb_substr($this->getFieldNewVal('name'), 0, 32, $parser->config['charset']));
    return '';
}

protected function _onDelete()
{
    global $parser;
    $this->recalcCategory();
    $fn = SYS_BASE_PATH.'userdata/modules/wproducts/wprod_products/'.$this->id;
    if(file_exists($fn)) $parser->utils->removeDir($fn, true);
    return '';
}

protected function _onBeforeDelete()
{
    global $parser;
    // Delete Photos
    $parser->conn->Execute("UPDATE wprod_products SET imageid=0, specprice=0 WHERE id=".$this->id);
    $w = new wproducts_models_photo();
    $w->productid = $this->id;
    return $w->deleteAll();
}

protected function _onBeforeUpdate()
{
    global $parser;
    $this->setFieldAttr('updateon', 'ro', 0);
    $this->setFieldNewVal('updateon', $parser->utils->toDate('', true));
    if($this->getFieldVal('price') !=  $this->getFieldNewVal('price'))
    {
        $this->setFieldAttr('taxprice', 'ro', 0);
        $this->setFieldNewVal('taxprice', $this->addTaxes($this->getFieldNewVal('price')));
    }
    if($this->getFieldVal('cost') !=  $this->getFieldNewVal('cost'))
    {
        $this->setFieldAttr('taxcost', 'ro', 0);
        $this->setFieldNewVal('taxcost', $this->addTaxes($this->getFieldNewVal('cost')));
    }
    return '';
}

protected function _onUpdate()
{
    $this->setFieldAttr('updateon', 'ro', 1);
    $this->setFieldAttr('taxprice', 'ro', 1);
    $this->setFieldAttr('taxcost', 'ro', 1);
    if($this->fields->category->val != $this->fields->category->newval)
    {
         $this->recalcCategory($this->fields->category->val);
         $this->recalcCategory($this->fields->category->newval);
    }
    if($this->fields->published->val != $this->fields->published->newval)
        $this->recalcCategory();
    $this->addLang();
    return '';
}


protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        $this->setFieldVal('taxclass', $parser->gs('wprod_setting_taxclass'));
        $this->setFieldVal('prodtype', $parser->gs('wprod_setting_prodtype'));
        $this->setFieldVal('weightclass', $parser->gs('wprod_setting_weightclass'));
        $this->setFieldVal('lengthclass', $parser->gs('wprod_setting_lengthclass'));
        $this->setFieldVal('qtyclass', $parser->gs('wprod_setting_qtyclass'));
        $this->setFieldVal('volumeclass', $parser->gs('wprod_setting_volclass'));
    } else
    {
        $this->setFieldAttr('income', 'notes', '&nbsp;&nbsp;'.$parser->gt('stockqty').'&nbsp;&nbsp;'.
            ($this->getFieldNewVal('income') -  $this->getFieldNewVal('expense')));
        if(trim($this->fields->www->val))
            $this->fields->www->label = "<b><a href=\"".$this->fields->www->val."\" target=\"_new\">www</a></b>";
    }
    $this->setFieldAttr('specprice', 'sqlid', 'wprod_sql1');
    $this->setFieldAttr('specprice', 'sql_pars', "group=&masterid=".$this->id);
    $this->setFieldAttr('imageid', 'sqlid', 'wprod_sql2');
    $this->setFieldAttr('imageid', 'sql_pars', "masterid=".$this->id);
    return '';
}

public function deleteAll($where = '', $sel = '')
{
    global $parser;
    if(!$this->category) return '';
    $this->recalc = false;
    $this->extra_deleteAll_sql = "";
    parent::deleteAll(($where) ? $where : 'WHERE category IN('.$this->category.')', $sel);
    $this->recalc = true;
    return $this->recalcCategory($this->category);
}

public function recalcCategory($cat = 0)
{
    global $parser;
    if(!$this->recalc) return;
    if(!$cat) $cat = $this->getFieldNewVal('category');
    $total = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_products WHERE category=".$cat, 0);
    $etotal = $parser->utils->getFieldFromSql("SELECT COUNT(*)
                                               FROM wprod_products p, wprod_categories c
                                               WHERE (p.published=1)
                                               AND (c.published=1)
                                               AND (c.id=p.category)
                                               AND (p.category=".$cat.")", 0);
    $parser->conn->Execute("UPDATE wprod_categories SET totalitems=".$total.", enitems=".$etotal." WHERE id=".$cat);
    while($cat)
    {
        $parent = $parser->utils->getFieldFromSql("SELECT parent FROM wprod_categories WHERE id=".$cat, 0);
        $a = $parser->utils->getFieldsFromSql("SELECT SUM(totalitems), SUM(CASE WHEN published=1 THEN enitems ELSE 0 END) FROM wprod_categories WHERE parent=".$parent, array(0,0), 'num');
        $parser->conn->Execute("UPDATE wprod_categories SET totalitems=".$a[0].", enitems=".$a[1]." WHERE id=".$parent);
        $cat = $parent;
    }
}

public function getActualPrice()
{
    global $parser;
    if(!$this->getFieldVal('specprice')) return $this->getFieldVal('price');
    $a = $parser->utils->getFieldsFromSql("SELECT flt1, flt2, flt3 FROM wprod_products_prop
                                           WHERE (id=".$this->getFieldVal('specprice').")
                                           AND (date1<=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                           AND (date2>=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                           ", array(0,0,0), 'num');
    if(!$a[0] and !$a[2]) return $this->getFieldVal('price');
    if($a[0]) return $a[0];
    return $parser->utils->mround($this->getFieldVal('price') * (100 - $a[2]) / 100, $parser->gs('wprod_setting_roundprice'));
}

public function getPresent()
{
    global $parser;
    $res = array('id' => 0, 'name' => '', 'artikul' => '', 'ico' => '', 'ico2' => '');
    if(!$this->getFieldVal('specprice')) return $res;

    $p = $parser->utils->getFieldsFromSql("SELECT p.imageid, p.name_".$parser->lang_suff.", i.filetype, p.artikul, p.id
                                                 FROM wprod_products p, wprod_products_photo i, wprod_products_prop pp
                                                 WHERE (pp.id=".$this->getFieldVal('specprice').")
                                                 AND (p.id=pp.ref1)
                                                 AND (p.imageid=i.id)
                                                 AND (pp.date1<=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                                 AND (pp.date2>=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                                 ", array(0,'','','',0), 'num');
    $res['id'] = $p[4];
    $res['name'] = $p[1];
    $res['artikul'] = $p[3];
    $imext = (trim($p[2])) ? $p[2] : 'jpg';
    $res['ico'] = ($p[0]) ? SYS_BASE_URL."userdata/modules/wproducts/wprod_products_photo/icons/".$p[0].".".$imext : SYS_BASE_URL."main/images/icons/noimage.png";
    $res['ico2'] = ($p[0]) ? SYS_BASE_URL."userdata/modules/wproducts/wprod_products_photo/icons/".$p[0]."_2.".$imext : SYS_BASE_URL."main/images/icons/noimage.png";
    return $res;
}

protected function _onInsert()
{
    $this->recalcCategory();
    $this->setFieldAttr('taxprice', 'ro', 1);
    $this->setFieldAttr('taxcost', 'ro', 1);
    $this->addLang();
    return '';
}

public function getActualTaxPrice()
{
    global $parser;
    if(!$this->getFieldVal('specprice')) return $this->getFieldVal('taxprice');
    $a = $parser->utils->getFieldsFromSql("SELECT flt1, flt2, flt3 FROM wprod_products_prop
                                           WHERE (id=".$this->getFieldVal('specprice').")
                                           AND (date1<=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                           AND (date2>=".$parser->conn->DBDate(adodb_date('Y-m-d')).")
                                           ", array(0,0,0), 'num');
    if(!$a[0] and !$a[2]) return $this->getFieldVal('taxprice');
    if($a[1]) return $a[1];
    return $parser->utils->mround($this->getFieldVal('taxprice') * (100 - $a[2]) / 100, $parser->gs('wprod_setting_roundtaxprice'));
}

public function addTaxes($price = 0, $taxclass = '', $zone = '', $roundto = -1)
{
    global $parser;
    if(!$price) return $price;
    if(!$taxclass) $taxclass = $this->getFieldNewVal('taxclass');
    if(!$zone) $zone = $parser->gs('wprod_setting_shopzone');
    // Read taxes from class

    $sql = "SELECT flt1, flt2, flt3, description
            FROM sys_objects
            WHERE (objtype='sys_taxes_rates')
            AND (ref1='".$zone."')
            AND (ref2='".$taxclass."')
            ORDER BY flt3";
    $rs = $parser->conn->Execute($sql);
    if($rs->NumRows() <= 0)
    {
        $sql = "SELECT flt1, flt2, flt3, description
                FROM sys_objects
                WHERE (objtype='sys_taxes_rates')
                AND (ref1='0')
                AND (ref2='".$taxclass."')
                ORDER BY flt3";
        $rs = $parser->conn->Execute($sql);
    }
    if($rs->NumRows() <= 0) return $price;

    $taxpr = 0;
    $taxsum = 0;
    while($row = $rs->FetchRow())
    {
        $taxpr += $row[0];
        $taxsum += $row[1];
        $formula = trim($row[3]);
        if($formula) eval($formula);
    }
    return $parser->utils->mround($price + $price * $taxpr / 100 + $taxsum, ($roundto == -1) ? $parser->gs('wprod_setting_roundtaxprice') : $roundto);
}

public function subTaxes($price = 0, $taxclass = '', $zone = '', $roundto = -1)
{
    global $parser;
    if(!$price) return $price;
    if(!$taxclass) $taxclass = $this->getFieldNewVal('taxclass');
    if(!$zone) $zone = $parser->gs('wprod_setting_shopzone');
    // Read taxes from class

    $sql = "SELECT flt1, flt2, flt3, description
            FROM sys_objects
            WHERE (objtype='sys_taxes_rates')
            AND (ref1='".$zone."')
            AND (ref2='".$taxclass."')
            ORDER BY flt3";
    $rs = $parser->conn->Execute($sql);
    if($rs->NumRows() <= 0)
    {
        $sql = "SELECT flt1, flt2, flt3, description
                FROM sys_objects
                WHERE (objtype='sys_taxes_rates')
                AND (ref1='0')
                AND (ref2='".$taxclass."')
                ORDER BY flt3";
        $rs = $parser->conn->Execute($sql);
    }
    if($rs->NumRows() <= 0) return $price;

    $taxpr = 0;
    $taxsum = 0;
    while($row = $rs->FetchRow())
    {
        $taxpr += $row[0];
        $taxsum += $row[1];
        $formula = trim($row[3]);
        if($formula) eval($formula);
    }
    $price -= $taxsum;
    return $parser->utils->mround($price / ((100 + $taxpr )/ 100), ($roundto == -1) ? $parser->gs('wprod_setting_roundprice') : $roundto);
}

public function taxedPrice($price = 0, $taxprice = 0, $taxclass = 0, $zone = 0, $roundto = -1)
{
    global $parser;
    if(!$price) return 0;
    if(!$taxclass) return $price;
    //if(!$zone) $zone = $_SESSION['wcomm']['active_client_zone'];
    if(!$zone) $zone = $parser->gs('sys_user_geozone');
    if($zone == $parser->gs('sys_user_geozone')) return $taxprice;
    // Read taxes from class

    $sql = "SELECT flt1, flt2, flt3, description
            FROM sys_objects
            WHERE (objtype='sys_taxes_rates')
            AND (ref1='".$zone."')
            AND (ref2='".$taxclass."')
            ORDER BY flt3";
    $rs = $parser->conn->Execute($sql);
    if($rs->NumRows() <= 0)
    {
        $sql = "SELECT flt1, flt2, flt3, description
                FROM sys_objects
                WHERE (objtype='sys_taxes_rates')
                AND (ref1='0')
                AND (ref2='".$taxclass."')
                ORDER BY flt3";
        $rs = $parser->conn->Execute($sql);
    }
    if($rs->NumRows() <= 0) return $price;

    $taxpr = 0;
    $taxsum = 0;
    while($row = $rs->FetchRow())
    {
        $taxpr += $row[0];
        $taxsum += $row[1];
        $formula = trim($row[3]);
        if($formula) eval($formula);
    }
    return $parser->utils->mround($price + $price * $taxpr / 100 + $taxsum, ($roundto == -1) ? $parser->gs('wprod_setting_roundtaxprice') : $roundto);
}

protected function _onBeforeReadRefVal($fld = '', $type = '', $val = '')
{
    global $parser;
    switch($fld)
    {
        case 'qtyclass': return $parser->utils->getFieldFromSql("SELECT str1_".$parser->lang_suff." FROM ".
                                "sys_objects WHERE objid = '".$val."'", '');
    }

    return '';
}

public function addLang($lang = '')
{
    global $parser;
    if(!$parser->config['seo_default_lang']) return;
    $extra_sql = ($lang) ? " AND lang='".$lang."'" : '';
    if($parser->utils->getFieldFromSql("SELECT id FROM wprod_products_lang ".
                                "WHERE productid=".$this->id.$extra_sql, 0)) return;
    $f = new wproducts_models_productslang();
    $f->fields->productid->val = $this->id;
    $f->fields->name->val = $this->fields->name->val;
    $f->fields->shortname->val = $this->fields->shortname->val;
    $f->fields->url->val = $this->fields->url->val;
    $f->fields->description->val = $this->fields->description->val;
    $f->fields->shortdescr->val = $this->fields->shortdescr->val;
    $f->fields->meta_title->val = $this->fields->meta_title->val;
    $f->fields->meta_h1->val = $this->fields->meta_h1->val;
    $f->fields->meta_keywords->val = $this->fields->meta_keywords->val;
    $f->fields->meta_description->val = $this->fields->meta_description->val;

    if($lang)
    {
        $f->fields->lang->val = $lang;
        $f->insert();
        return '';
    }

    $rs = $parser->conn->Execute("SELECT objid, str1_".$parser->lang_suff.
    " FROM sys_objects WHERE objtype='sys_langs' and bool1=1");
    while($row = $rs->FetchRow())
    {
        $f->fields->lang->val = $row[1];
        $f->insert();
    }

}

}

?>