<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_rates extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_rates');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}

protected function _onBeforeInsert()
{
    $this->id = 0;
    $s = $this->checkPars();
    if($s) return $s;
    return '';
}

protected function _onBeforeUpdate()
{
    $this->setFieldAttr('taxprice', 'ro', 0);
    $s = $this->checkPars();
    if($s) return $s;
    return '';
}

protected function _onUpdate()
{
    $this->setFieldAttr('taxprice', 'ro', 1);
    return '';
}

protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        if(!$this->fields->starton->val) $this->fields->starton->val = $parser->utils->toDate('');
        if(!$this->fields->finishon->val) $this->fields->finishon->val = $parser->utils->dateToStr($parser->utils->shiftDates($parser->utils->toDate(''), 30, 'd'));
        //$this->fields->starton->val = $parser->utils->toDate('');
    } else
    {

    }
    $sql = " AND (prodtype='wprod_prodtypes_estate') ";
    $this->setFieldAttr('productid', 'extra_pars', $sql);
    return '';
}

public function checkPars()
{
    global $parser;

    $p = new wproducts_models_products();
    $p->id = $this->fields->productid->val;
    $p->read();
    $this->setFieldNewVal('taxprice', $p->addTaxes($this->getFieldNewVal('price')));

    $days =  ($parser->utils->strToDate($this->fields->finishon->newval)
    - $parser->utils->strToDate($this->fields->starton->newval)) / (3600*24) + 1;

    if($days <= 0) return $parser->gt('badperiod');
    $from = $parser->conn->DBDate($parser->utils->dateToISOformat($this->fields->starton->newval));
    $to = $parser->conn->DBDate($parser->utils->dateToISOformat($this->fields->finishon->newval));
    $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_rates
                                          WHERE (productid=".$this->fields->productid->val.")
                                          AND (id<>".$this->id.")
                                          AND
                                          (
                                              (starton BETWEEN ".$from." AND ".$to.")
                                              OR
                                              (finishon BETWEEN ".$from." AND ".$to.")
                                          )
                                          ", '');
    if($n) return $parser->gt('objectbusy');

    return '';
}


public function onBeforeCopy($id = 0)
{
    parent::onBeforeCopy($id);
    return '';
}

public function onCopy($id = 0)
{
    //global $parser;
    // Copy subobjects from original object

    return '';
}

}

?>